#include "audiodata.h"

AudioData::AudioData(int p_bufsize){

  bufsize = p_bufsize;  
  buf = (unsigned char*)malloc(bufsize);
  readofs = 0;
  writeofs = 0;
  rate = DEFAULT_RATE;
  periodsize = DEFAULT_PERIODSIZE;
  periods = DEFAULT_PERIODS;
  channels = DEFAULT_CHANNELS;
  samplesize = DEFAULT_SAMPLESIZE;
  frames = periodsize / (samplesize * channels);
  framesize = samplesize * channels;
  doCapture = false;
  min = -32767;
  max = 32768;
}

AudioData::~AudioData(){        
  
  free(buf);
}

int AudioData::setPeriodsize(int p_periodsize){

  periodsize = p_periodsize;
  frames = periodsize / (framesize);
  return(periodsize);
}

int AudioData::setPeriods(int p_periods){

  periods = p_periods;
  return(periods);
}

int AudioData::setRate(int p_rate){

  rate = p_rate;
  return(rate);   
}

int AudioData::setChannels(int p_channels){

  channels = p_channels;
  frames = periodsize / (samplesize * channels);
  framesize = samplesize * channels;
  return(channels);  
}
