#ifndef KAUDIODATA_H
#define KAUDIODATA_H

#include <stdio.h>
#include <stdlib.h>
#include <qobject.h>
#include <qthread.h>
#include <alsa/asoundlib.h>

#define DEFAULT_RATE            44100
#define DEFAULT_PERIODSIZE      16384
#define DEFAULT_PERIODS             2
#define DEFAULT_CHANNELS            2
#define DEFAULT_SAMPLESIZE          2

class AudioData : public QObject
{
  public:
    unsigned char *buf;
    int bufsize, readofs, writeofs;
    int periodsize;
    int periods;
    int rate;
    int channels;
    int frames;
    int framesize;
    int samplesize;
    int min, max;
    snd_pcm_t *pcm_capture_handle;
    bool doCapture;

  public:
    AudioData(int p_bufsize);
    ~AudioData();
    int setPeriodsize(int p_periodsize);
    int setPeriods(int p_periods);
    int setRate(int p_rate);
    int setChannels(int p_channels);
};

#endif

