#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>
#include <qsignal.h>
#include "capture.h"

Capture::Capture(AudioData *p_adata){

  adata = p_adata;
}

Capture::~Capture(){

}

void Capture::run(){

  int pcmreturn;

  while(adata->doCapture) {
#if SND_LIB_MINOR >= 6 || SND_LIB_MAJOR >= 1
    while ((pcmreturn = snd_pcm_readi(adata->pcm_capture_handle, adata->buf + adata->writeofs, adata->frames)) < 0) {
      snd_pcm_prepare(adata->pcm_capture_handle);
      fprintf(stderr, "<<<<<<<<<<<<<<< Buffer Overrun >>>>>>>>>>>>>>>\n");
    }
    if (pcmreturn != adata->frames) {
      fprintf(stderr, "Error: Missed some frames.");
    }
#else
    while ((pcmreturn = snd_pcm_read(adata->pcm_capture_handle, adata->buf + adata->writeofs, adata->periodsize)) < 0) {
      snd_pcm_channel_flush(adata->pcm_capture_handle, SND_PCM_CHANNEL_CAPTURE);
      snd_pcm_channel_prepare(adata->pcm_capture_handle, SND_PCM_CHANNEL_CAPTURE);
      fprintf(stderr, "<<<<<<<<<<<<<<< Buffer Overrun >>>>>>>>>>>>>>>\n");
    }
    if (pcmreturn != adata->periodsize) {
      fprintf(stderr, "Error: Missed some frames.");
    }
#endif
    adata->writeofs += adata->periodsize;
    if (adata->writeofs >= adata->bufsize) {
      adata->writeofs = 0;
    }
  }
}
