#ifndef KWAVEVIEW_H
#define KWAVEVIEW_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <qwidget.h>
#include <qstring.h>
#include <qslider.h>   
#include <qcheckbox.h>  
#include <qlabel.h>
#include <qmessagebox.h>
#include <alsa/asoundlib.h>
#include "audiodata.h"
#include "capture.h"
#include "scope.h"
#include "spectrum.h"

#if SND_LIB_MINOR >= 6 || SND_LIB_MAJOR >= 1
#define DEFAULT_PCMNAME    "plughw:0,0"
#else
#define DEFAULT_CARD                0
#define DEFAULT_DEVICE              0
#endif

#define DEFAULT_WIDTH             650
#define DEFAULT_HEIGHT            500
#define BUFSIZE                524288

class KWaveView : public QVBox
{
  Q_OBJECT

  private:
    AudioData *adata;
    Scope *scope;
    Spectrum *spectrum;
    QMessageBox *aboutWidget;
    Capture *capture;
#if SND_LIB_MINOR >= 6 || SND_LIB_MAJOR >= 1
    QString PCMname;
    snd_seq_t *seq_handle;
#else
    int PCMcard;
    int PCMdevice;
#endif
    
  public:
    KWaveView(QWidget* parent=0, const char *name=0);
    ~KWaveView();
    int go();
    int setPeriodsize(int periodsize);
    int setPeriods(int periods);
    int setRate(int rate);
    int setChannels(int channels);
#if SND_LIB_MINOR >= 6 || SND_LIB_MAJOR >= 1
    int setPCMname(QString name);
    void open_seq();
    int initSeqNotifier();    
#else    
    int setPCMcard(int card);
    int setPCMdevice(int device);
#endif
    snd_pcm_t *open_pcm_capture();
    
  public slots: 
    void displayAbout();
    void displaySpectrum();
#if SND_LIB_MINOR >= 6 || SND_LIB_MAJOR >= 1
    void midiAction(int fd);
#endif    
};
  
#endif
      
